//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  ReLXgj[ R|[lg̃eXg
//  DelphiɕtShellControlR|[lg̎gpƒ
//
//-----------------------------------------------------------------------------
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ComCtrls, ShellCtrls, ExtCtrls, StdCtrls, plContextMenu;

type
  TForm1 = class(TForm)
    Panel2: TPanel;
    ShellTreeView1: TShellTreeView;
    ShellListView1: TShellListView;
    plContextMenu1: TplContextMenu;
    Panel1: TPanel;
    Edit1: TEdit;
    Splitter1: TSplitter;
    plDropSource1: TplDropSource;
    plContextMenu2: TplContextMenu;
    Button1: TButton;
    procedure plContextMenu1Popup(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ShellListView1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure plContextMenu2Popup(Sender: TObject);
    procedure plContextMenu1ContextMenuClose(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses ShlObj, ActiveX;

{$R *.dfm}

//=============================================================================
//  TShellListView.AutoContextMenusTruȅꍇCTShellListView̃ReLX
//  gj[gp
//  AutoRefresh́C̃ReLXgj[̑ĎXbhgp
//  邽߁C{R|쒆ɎsĂƁCXbhG[ŁCXbhI
//  łȂȂ
//=============================================================================
procedure TForm1.FormShow(Sender: TObject);
begin
  ShellListView1.AutoRefresh      := True;
  ShellListView1.AutoContextMenus := False;

  ShellTreeView1.AutoRefresh      := False;
  ShellTreeView1.AutoContextMenus := False;
end;

//=============================================================================
//  [߂]{^
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
begin
  ShellListView1.Back;
end;

//=============================================================================
//  TplContextMenuR|OnPopupCxg
//  ShellListViewp
//  AutoRefreshFalseɂāCTShellListVieẘĎXbh𖳌ɂ
//
//  GetFullPathFromAbsPItemID̓R|Œ`Ă֐ŁCtpX̍
//  ڎʎq(SPIDL)t@CVXẽtpX߂֐
//  ̊֐ŋ߂tpXł΁CΏۃtH_ztH_łĂCR
//  eLXgj[\
//
//  []
//  ̃R[hŎ擾pidl̓R[hŉȂ
//  Item擾đĂ̂ŁC͓ꏊƂȂĂCILClone
//  ŃRs[ꍇ͉
//=============================================================================
procedure TForm1.plContextMenu1Popup(Sender: TObject);
var
  LDirectory : String;
  LFullPath  : String;
  Lpidl      : PItemIDList;
  LSelItem   : TListItem;
  LFileName  : String;
begin
  ShellListView1.AutoRefresh := False;
  plContextMenu1.Files.Clear;

  //DirectoryvpeB̐ݒ
  LDirectory := GetFullPathFromAbsPItemID(ShellListView1.RootFolder.AbsoluteID);
  Edit1.Text := LDirectory;
  plContextMenu1.Directory := LDirectory;

  //I𒆂Item珇ԂɃtpX擾Ă
  LSelItem := ShellListView1.Selected;
  while LSelItem <> nil do begin
    Lpidl := ShellListView1.Folders[LSelItem.Index].AbsoluteID;

    if Lpidl <> nil then begin
      //hCu'D:\'̂悤Ɏw肷Kv̂Ń`FbN
      LFullPath  := GetFullPathFromAbsPItemID(Lpidl);
      LDirectory := IncludeTrailingPathDelimiter(LFullPath);
      if LDirectory = ExtractFileDir(LDirectory) then begin
        LFileName := LDirectory;
      end else begin
        LFileName := ExtractFileName(LFullPath);
      end;

      plContextMenu1.Files.Add(LFileName);
      LSelItem := ShellListView1.GetNextItem(LSelItem, sdAll, [isSelected]);
    end;
  end;
end;

//=============================================================================
//  TplContextMenuR|OnvContextMenuCloseCxg
//  ShellListViewp
//=============================================================================
procedure TForm1.plContextMenu1ContextMenuClose(Sender: TObject);
begin
  ShellListView1.AutoRefresh := True;
end;

//=============================================================================
//  TSellListViewOnMouseDownCxg
//  hbv\[XR|̃eXg
//  I𒆂̃t@C̃hbOJn
//=============================================================================
procedure TForm1.ShellListView1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  LSelItem  : TListItem;
  LFileName : String;
begin
  ShellListView1.AutoRefresh := False;

  if (Button = mbRight) or (Button = mbLeft) then begin
    plDropSource1.Files.Clear;

    plDropSource1.Directory := ShellListView1.RootFolder.PathName;

    //I𒆂Item珇ԂɃtpX擾Ă
    //ItemCaptionƁCgq\ĂȂt@C擾łȂ
    LSelItem := ShellListView1.Selected;
    while LSelItem <> nil do begin
      LFileName := ExtractFileName(ShellListView1.Folders[LSelItem.Index].PathName);
      plDropSource1.Files.Add(LFileName);
      LSelItem := ShellListView1.GetNextItem(LSelItem, sdAll, [isSelected]);
    end;
    plDropSource1.DoDrop(ShellListView1.Handle);
    ShellListView1.AutoRefresh := True;
  end;
end;

//=============================================================================
//  TplContextMenuR|OnPopupCxg
//  ShellTreeViewp
//
//  ł̓t@CVXẽtH_DirectoryvpeBɃZbg
//  GetFullPathFromAbsPItemIDgpāCڎʎq擾ĂȂ̂ŁC
//  ztH_ł̓ReLXgj[\Ȃ
//=============================================================================
procedure TForm1.plContextMenu2Popup(Sender: TObject);
var
  LDirectory : String;
begin
  plContextMenu2.Files.Clear;

  if ShellTreeView1.Selected <> nil then begin
    LDirectory := ShellTreeView1.SelectedFolder.PathName;
    Edit1.Text := LDirectory;
    plContextMenu2.Directory := LDirectory;
  end;
end;

end.
